import * as React from "react";
import { TGetPositionFromEvent } from "../../controllers";
import { IEvent } from "../../models/event";
import { ICanvasEdge } from "../../models/edge";
import { GraphModel } from "../../models/GraphModel";
import { ICanvasNode } from "../../models/node";
import { NodeModel } from "../../models/NodeModel";
import { ICanvasPort } from "../../models/port";
import { CanvasMouseMode } from "../../models/state";
export interface IGraphProps<NodeData = unknown, EdgeData = unknown, PortData = unknown> {
    title?: string;
    desc?: string;
    style?: React.CSSProperties;
    classes?: IGraphClasses;
    styles?: IGraphStyles;
    canvasMouseMode?: CanvasMouseMode;
    svgRef?: React.RefObject<SVGSVGElement>;
    focusCanvasAccessKey?: string;
    zoomSensitivity?: number;
    scrollSensitivity?: number;
    dragThreshold?: number;
    autoAlignThreshold?: number;
    getPositionFromEvent?: TGetPositionFromEvent;
    virtualizationDelay?: number;
    onBrowserNotSupported?(): React.ReactChild;
    edgeWillAdd?(edge: ICanvasEdge<EdgeData>, data: GraphModel<NodeData, EdgeData, PortData>): ICanvasEdge;
    getNodeAriaLabel?(node: ICanvasNode<NodeData, PortData>): string | undefined;
    getPortAriaLabel?(data: GraphModel<NodeData, EdgeData, PortData>, node: NodeModel<NodeData, PortData>, port: ICanvasPort<PortData>): string | undefined;
    onEvent?(event: IEvent<NodeData, EdgeData, PortData>): void;
}
export interface IGraphClasses {
    root?: string;
    svg?: string;
}
export interface IGraphStyles {
    root?: React.CSSProperties;
    svg?: React.CSSProperties;
    connectingLine?: React.CSSProperties;
    alignmentLine?: React.CSSProperties;
    selectBox?: React.CSSProperties;
}
//# sourceMappingURL=IGraphProps.d.ts.map