import * as React from "react";
import { IDispatch } from "../contexts";
import type { IGraphState } from "../models/state";
import { IThemeProviderProps } from "./ThemeProvider";
export interface IReactDagEditorProps<NodeData = unknown, EdgeData = unknown, PortData = unknown, Action = never> extends IThemeProviderProps {
    style?: React.CSSProperties;
    className?: string;
    state: IGraphState<NodeData, EdgeData, PortData>;
    dispatch: IDispatch<NodeData, EdgeData, PortData, Action>;
    handleWarning?(message: string): void;
    handleError?(error?: Error, errorInfo?: React.ErrorInfo, children?: React.ReactNode): React.ReactChild;
    getGlobalEventTarget?(): Window | Element | null | undefined;
}
export declare const ReactDagEditor: React.FunctionComponent<IReactDagEditorProps>;
//# sourceMappingURL=ReactDagEditor.d.ts.map