import * as React from "react";
export interface IContextMenuProps {
    className?: string;
    styles?: React.CSSProperties;
}
export declare enum MenuType {
    Node = "node",
    Edge = "edge",
    Port = "port",
    Canvas = "canvas",
    Multi = "multi"
}
export interface IContextMenuConfig {
    registerContextMenu(props: IContextMenuProps): void;
    registerMenu(element: React.ReactNode, menuType: MenuType): void;
    getMenu(menuType: MenuType): React.ReactNode;
}
export declare class ContextMenuConfig implements IContextMenuConfig {
    private readonly contextMenu;
    private contextMenuProps;
    registerContextMenu(props: IContextMenuProps): void;
    registerMenu(element: React.ReactNode, menuType: MenuType): void;
    getMenu(menuType: MenuType): React.ReactNode;
}
export declare const ContextMenuConfigContext: React.Context<IContextMenuConfig>;
//# sourceMappingURL=ContextMenuConfigContext.d.ts.map