import * as React from "react";
import type { IEvent } from "../models/event";
import type { IGap, IRectSize, ITransformMatrix, IViewport } from "../models/geometry";
import { GraphModel } from "../models/GraphModel";
import { IGraphSettings, IGraphState } from "../models/state";
export declare const EMPTY_TRANSFORM_MATRIX: ITransformMatrix;
export declare const EMPTY_VIEW_PORT: IViewport;
export declare const EMPTY_GAP: IGap;
export declare const DEFAULT_NODE_MIN_VISIBLE_SIZE: IRectSize;
export declare const DEFAULT_NODE_MAX_VISIBLE_SIZE: IRectSize;
export declare const DEFAULT_GRAPH_SETTINGS: IGraphSettings;
export declare const EMPTY_GRAPH_STATE: IGraphState;
export declare const defaultGraphStateContext: IGraphStateContext;
export declare type TDataComposer<NodeData = unknown, EdgeData = unknown, PortData = unknown> = (prev: GraphModel<NodeData, EdgeData, PortData>, prevState: IGraphState<NodeData, EdgeData, PortData>) => GraphModel<NodeData, EdgeData, PortData>;
export declare const EMPTY_CONNECT_STATE: {
    sourceNode: undefined;
    sourcePort: undefined;
    targetNode: undefined;
    targetPort: undefined;
    movingPoint: {
        x: number;
        y: number;
    };
};
export declare type IGraphAction<NodeData = unknown, EdgeData = unknown, PortData = unknown> = IEvent<NodeData, EdgeData, PortData>;
export declare type IDispatchCallback<NodeData = unknown, EdgeData = unknown, PortData = unknown> = (state: IGraphState<NodeData, EdgeData, PortData>, prevState: IGraphState<NodeData, EdgeData, PortData>) => void;
export declare type IDispatch<NodeData = unknown, EdgeData = unknown, PortData = unknown, Action = never> = (action: IEvent<NodeData, EdgeData, PortData> | Action, callback?: IDispatchCallback<NodeData, EdgeData, PortData>) => void;
export interface IGraphStateContext<NodeData = unknown, EdgeData = unknown, PortData = unknown, Action = never> {
    state: IGraphState<NodeData, EdgeData, PortData>;
    dispatch: IDispatch<NodeData, EdgeData, PortData, Action>;
}
export declare const GraphValueContext: React.Context<GraphModel<unknown, unknown, unknown>>;
export declare const GraphStateContext: React.Context<IGraphStateContext<unknown, unknown, unknown, never>>;
export declare type IGraphReactReducer<NodeData = unknown, EdgeData = unknown, PortData = unknown, Action = never> = React.Reducer<IGraphState<NodeData, EdgeData, PortData>, IEvent<NodeData, EdgeData, PortData> | Action>;
export declare type IGraphReducer<NodeData = unknown, EdgeData = unknown, PortData = unknown, Action = never> = (next: IGraphReactReducer<NodeData, EdgeData, PortData, Action>) => IGraphReactReducer<NodeData, EdgeData, PortData, Action>;
export declare const setData: <NodeData = unknown, EdgeData = unknown, PortData = unknown>(state: IGraphState<NodeData, EdgeData, PortData>, data: GraphModel<NodeData, EdgeData, PortData>) => IGraphState<NodeData, EdgeData, PortData>;
export declare const updateData: <NodeData = unknown, EdgeData = unknown, PortData = unknown>(state: IGraphState<NodeData, EdgeData, PortData>, f: (data: GraphModel<NodeData, EdgeData, PortData>) => GraphModel<NodeData, EdgeData, PortData>) => IGraphState<NodeData, EdgeData, PortData>;
//# sourceMappingURL=GraphStateContext.d.ts.map