import { IDispatch } from "../contexts";
import { GraphFeatures } from "../Features";
import { IPoint } from "../models/geometry";
import { GraphModel } from "../models/GraphModel";
import { NodeModel } from "../models/NodeModel";
import { GraphBehavior, IGraphState } from "../models/state";
import { EventChannel } from "../utils/eventChannel";
export declare class GraphController {
    pointerId: number | null;
    canvasClickOnce: boolean;
    nodeClickOnce: NodeModel | null;
    readonly eventChannel: EventChannel;
    state: IGraphState;
    UNSAFE_latestState: IGraphState;
    dispatch: IDispatch;
    getGlobalEventTargetImpl?: () => Window | Element | null | undefined;
    private mouseClientPoint?;
    private behavior;
    constructor(state: IGraphState, dispatch: IDispatch);
    setMouseClientPosition(pos: IPoint): void;
    unsetMouseClientPosition(): void;
    getMouseClientPosition(): IPoint | undefined;
    getEnabledFeatures(): ReadonlySet<GraphFeatures>;
    getBehavior(): GraphBehavior;
    setBehavior(value: GraphBehavior): void;
    getData(): GraphModel;
    getGlobalEventTarget(): Element | Window;
}
//# sourceMappingURL=GraphController.d.ts.map