import { IEventProvider, IGlobalMoveEventTypes } from "../event-provider/types";
import { $Cons } from "../utils/tuple";
import { ITouchHandler } from "./TouchController";
export declare class TouchDragAdapter<ExtraArgs extends unknown[] = []> implements IEventProvider<IGlobalMoveEventTypes<ExtraArgs>>, ITouchHandler<ExtraArgs> {
    private readonly startListeners;
    private readonly moveListeners;
    private readonly endListeners;
    off(type: "start" | "move" | "end", callback: (...args: $Cons<MouseEvent, ExtraArgs>) => void): TouchDragAdapter<ExtraArgs>;
    on(type: "start" | "move" | "end", callback: (...args: $Cons<MouseEvent, ExtraArgs>) => void): TouchDragAdapter<ExtraArgs>;
    onStart(events: Map<number, PointerEvent>, e: PointerEvent, ...args: ExtraArgs): void;
    onMove(events: Map<number, PointerEvent>, e: PointerEvent, ...args: ExtraArgs): void;
    onEnd(e: PointerEvent, ...args: ExtraArgs): void;
}
//# sourceMappingURL=TouchDragAdapter.d.ts.map