import { $Complete } from "../utils/complete";
import { ICanvasEdge } from "./edge";
import { GraphEdgeState } from "./element-state";
export declare class EdgeModel<T = unknown> implements $Complete<ICanvasEdge> {
    readonly inner: ICanvasEdge<T>;
    get id(): string;
    get shape(): string | undefined;
    get automationId(): string | undefined;
    get source(): string;
    get target(): string;
    get sourcePortId(): string;
    get targetPortId(): string;
    get state(): GraphEdgeState | undefined;
    get data(): Readonly<T> | undefined;
    private constructor();
    static fromJSON<D>(inner: ICanvasEdge<D>): EdgeModel<D>;
    updateState(f: (state: number | undefined) => number): EdgeModel<T>;
    update(f: (curEdge: ICanvasEdge<T>) => ICanvasEdge<T>): EdgeModel<T>;
    shallow(): EdgeModel<T>;
    toJSON(): ICanvasEdge<T>;
}
//# sourceMappingURL=EdgeModel.d.ts.map