import type { IEdgeConfig, IGraphClipboard, IGraphConfig, IGroupConfig, INodeConfig, IPortConfig } from "./types";
export declare class GraphConfig<NodeData = unknown, EdgeData = unknown, PortData = unknown> implements IGraphConfig<NodeData, EdgeData, PortData> {
    readonly defaultEdgeShape: string;
    readonly defaultNodeShape: string;
    readonly defaultPortShape: string;
    readonly defaultGroupShape: string;
    readonly nodeConfigMap: ReadonlyMap<string, INodeConfig<NodeData, PortData>>;
    readonly edgeConfigMap: ReadonlyMap<string, IEdgeConfig<EdgeData>>;
    readonly portConfigMap: ReadonlyMap<string, IPortConfig<NodeData, EdgeData, PortData>>;
    readonly groupConfigMap: ReadonlyMap<string, IGroupConfig>;
    readonly clipboard: IGraphClipboard<NodeData, EdgeData, PortData>;
    constructor(defaultEdgeShape: string, defaultNodeShape: string, defaultPortShape: string, defaultGroupShape: string, nodeConfigMap: ReadonlyMap<string, INodeConfig<NodeData, PortData>>, edgeConfigMap: ReadonlyMap<string, IEdgeConfig<EdgeData>>, portConfigMap: ReadonlyMap<string, IPortConfig<NodeData, EdgeData, PortData>>, groupConfigMap: ReadonlyMap<string, IGroupConfig>, clipboard: IGraphClipboard<NodeData, EdgeData, PortData>);
    getClipboard(): IGraphClipboard<NodeData, EdgeData, PortData>;
    getEdgeConfigByName(name?: string): IEdgeConfig<EdgeData> | undefined;
    getGroupConfigByName(name?: string): IGroupConfig | undefined;
    getNodeConfigByName(name?: string): INodeConfig<NodeData, PortData> | undefined;
    getPortConfigByName(name?: string): IPortConfig<NodeData, EdgeData, PortData> | undefined;
}
//# sourceMappingURL=GraphConfig.d.ts.map