import { GraphConfig } from "./GraphConfig";
import type { IEdgeConfig, IGraphClipboard, IGroupConfig, INodeConfig, IPortConfig } from "./types";
export declare class GraphConfigBuilder<NodeData = unknown, EdgeData = unknown, PortData = unknown> {
    private defaultEdgeShape;
    private defaultNodeShape;
    private defaultPortShape;
    private defaultGroupShape;
    private readonly nodeConfigMap;
    private readonly edgeConfigMap;
    private readonly portConfigMap;
    private readonly groupConfigMap;
    private clipboard;
    private constructor();
    static default(): GraphConfigBuilder;
    static from(graphConfig: GraphConfig): GraphConfigBuilder;
    withDefaultEdgeShape(shape: string): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    withDefaultNodeShape(shape: string): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    withDefaultPortShape(shape: string): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    withDefaultGroupShape(shape: string): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    withClipboard(clipboard: IGraphClipboard<NodeData, EdgeData, PortData>): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    registerNode(name: string, config: INodeConfig<NodeData, PortData>): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    registerEdge(name: string, config: IEdgeConfig<EdgeData>): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    registerPort(name: string, config: IPortConfig<NodeData, EdgeData, PortData>): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    registerGroup(name: string, config: IGroupConfig): GraphConfigBuilder<NodeData, EdgeData, PortData>;
    build(): GraphConfig;
}
//# sourceMappingURL=GraphConfigBuilder.d.ts.map