export interface IHistoryNode<T> {
    next: IHistoryNode<T> | null;
    value: T;
}
export interface IHistory<T> {
    present: T;
    past: IHistoryNode<T> | null;
    future: IHistoryNode<T> | null;
}
export declare const pushHistory: <T>(history: IHistory<T>, data: T, mapPresent?: (value: T) => T) => IHistory<T>;
export declare const undo: <T>(history: IHistory<T>) => IHistory<T>;
export declare const redo: <T>(history: IHistory<T>) => IHistory<T>;
export declare const resetUndoStack: <T>(data: T) => IHistory<T>;
export declare const canUndo: <T>(history: IHistory<T>) => boolean;
export declare const canRedo: <T>(history: IHistory<T>) => boolean;
//# sourceMappingURL=history.d.ts.map