import type { OrderedMap } from "../collections";
import type { ICanvasGroup } from "../models/canvas";
import type { IGraphConfig, INodeConfig } from "../models/config/types";
import type { ICanvasNode } from "../models/node";
import type { NodeModel } from "../models/NodeModel";
export declare function getRectWidth<T>(rectConfig: INodeConfig<T> | undefined, rect: Partial<ICanvasNode<T>>): number;
export declare function getRectHeight<T>(rectConfig: INodeConfig<T> | undefined, rect: Partial<ICanvasNode<T>>): number;
export interface INodeRect {
    height: number;
    width: number;
}
export declare function getNodeSize(node: ICanvasNode, graphConfig: IGraphConfig): INodeRect;
export interface IShapePosition {
    x: number;
    y: number;
}
export interface IShapeRect extends INodeRect, IShapePosition {
}
export declare function getGroupRect<NodeData, PortData>(group: ICanvasGroup, nodes: OrderedMap<string, NodeModel<NodeData, PortData>>, graphConfig: IGraphConfig): IShapeRect;
//# sourceMappingURL=layout.d.ts.map