define(['exports'], function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function getDefaultExportFromCjs (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
    }

    function createCommonjsModule(fn, basedir, module) {
    	return module = {
    		path: basedir,
    		exports: {},
    		require: function (path, base) {
    			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
    		}
    	}, fn(module, module.exports), module.exports;
    }

    function commonjsRequire () {
    	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
    }

    var elkApi = createCommonjsModule(function (module, exports) {
    (function(f){{module.exports=f();}})(function(){return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof commonjsRequire&&commonjsRequire;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t);}return n[i].exports}for(var u="function"==typeof commonjsRequire&&commonjsRequire,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

    Object.defineProperty(exports, "__esModule", {
      value: true
    });

    var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    /*******************************************************************************
     * Copyright (c) 2017 Kiel University and others.
     * All rights reserved. This program and the accompanying materials
     * are made available under the terms of the Eclipse Public License v1.0
     * which accompanies this distribution, and is available at
     * http://www.eclipse.org/legal/epl-v10.html
     *******************************************************************************/
    var ELK = function () {
      function ELK() {
        var _this = this;

        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            _ref$defaultLayoutOpt = _ref.defaultLayoutOptions,
            defaultLayoutOptions = _ref$defaultLayoutOpt === undefined ? {} : _ref$defaultLayoutOpt,
            _ref$algorithms = _ref.algorithms,
            algorithms = _ref$algorithms === undefined ? ['layered', 'stress', 'mrtree', 'radial', 'force', 'disco', 'sporeOverlap', 'sporeCompaction', 'rectpacking'] : _ref$algorithms,
            workerFactory = _ref.workerFactory,
            workerUrl = _ref.workerUrl;

        _classCallCheck(this, ELK);

        this.defaultLayoutOptions = defaultLayoutOptions;
        this.initialized = false;

        // check valid worker construction possible
        if (typeof workerUrl === 'undefined' && typeof workerFactory === 'undefined') {
          throw new Error("Cannot construct an ELK without both 'workerUrl' and 'workerFactory'.");
        }
        var factory = workerFactory;
        if (typeof workerUrl !== 'undefined' && typeof workerFactory === 'undefined') {
          // use default Web Worker
          factory = function factory(url) {
            return new Worker(url);
          };
        }

        // create the worker
        var worker = factory(workerUrl);
        if (typeof worker.postMessage !== 'function') {
          throw new TypeError("Created worker does not provide" + " the required 'postMessage' function.");
        }

        // wrap the worker to return promises
        this.worker = new PromisedWorker(worker);

        // initially register algorithms
        this.worker.postMessage({
          cmd: 'register',
          algorithms: algorithms
        }).then(function (r) {
          return _this.initialized = true;
        }).catch(console.err);
      }

      _createClass(ELK, [{
        key: 'layout',
        value: function layout(graph) {
          var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
              _ref2$layoutOptions = _ref2.layoutOptions,
              layoutOptions = _ref2$layoutOptions === undefined ? this.defaultLayoutOptions : _ref2$layoutOptions,
              _ref2$logging = _ref2.logging,
              logging = _ref2$logging === undefined ? false : _ref2$logging,
              _ref2$measureExecutio = _ref2.measureExecutionTime,
              measureExecutionTime = _ref2$measureExecutio === undefined ? false : _ref2$measureExecutio;

          if (!graph) {
            return Promise.reject(new Error("Missing mandatory parameter 'graph'."));
          }
          return this.worker.postMessage({
            cmd: 'layout',
            graph: graph,
            layoutOptions: layoutOptions,
            options: {
              logging: logging,
              measureExecutionTime: measureExecutionTime
            }
          });
        }
      }, {
        key: 'knownLayoutAlgorithms',
        value: function knownLayoutAlgorithms() {
          return this.worker.postMessage({ cmd: 'algorithms' });
        }
      }, {
        key: 'knownLayoutOptions',
        value: function knownLayoutOptions() {
          return this.worker.postMessage({ cmd: 'options' });
        }
      }, {
        key: 'knownLayoutCategories',
        value: function knownLayoutCategories() {
          return this.worker.postMessage({ cmd: 'categories' });
        }
      }, {
        key: 'terminateWorker',
        value: function terminateWorker() {
          this.worker.terminate();
        }
      }]);

      return ELK;
    }();

    exports.default = ELK;

    var PromisedWorker = function () {
      function PromisedWorker(worker) {
        var _this2 = this;

        _classCallCheck(this, PromisedWorker);

        if (worker === undefined) {
          throw new Error("Missing mandatory parameter 'worker'.");
        }
        this.resolvers = {};
        this.worker = worker;
        this.worker.onmessage = function (answer) {
          // why is this necessary?
          setTimeout(function () {
            _this2.receive(_this2, answer);
          }, 0);
        };
      }

      _createClass(PromisedWorker, [{
        key: 'postMessage',
        value: function postMessage(msg) {
          var id = this.id || 0;
          this.id = id + 1;
          msg.id = id;
          var self = this;
          return new Promise(function (resolve, reject) {
            // prepare the resolver
            self.resolvers[id] = function (err, res) {
              if (err) {
                self.convertGwtStyleError(err);
                reject(err);
              } else {
                resolve(res);
              }
            };
            // post the message
            self.worker.postMessage(msg);
          });
        }
      }, {
        key: 'receive',
        value: function receive(self, answer) {
          var json = answer.data;
          var resolver = self.resolvers[json.id];
          if (resolver) {
            delete self.resolvers[json.id];
            if (json.error) {
              resolver(json.error);
            } else {
              resolver(null, json.data);
            }
          }
        }
      }, {
        key: 'terminate',
        value: function terminate() {
          if (this.worker.terminate) {
            this.worker.terminate();
          }
        }
      }, {
        key: 'convertGwtStyleError',
        value: function convertGwtStyleError(err) {
          if (!err) {
            return;
          }
          // Somewhat flatten the way GWT stores nested exception(s)
          var javaException = err['__java$exception'];
          if (javaException) {
            // Note that the property name of the nested exception is different
            // in the non-minified ('cause') and the minified (not deterministic) version.
            // Hence, the version below only works for the non-minified version.
            // However, as the minified stack trace is not of much use anyway, one
            // should switch the used version for debugging in such a case.
            if (javaException.cause && javaException.cause.backingJsObject) {
              err.cause = javaException.cause.backingJsObject;
              this.convertGwtStyleError(err.cause);
            }
            delete err['__java$exception'];
          }
        }
      }]);

      return PromisedWorker;
    }();
    },{}],2:[function(require,module,exports){

    var ELK = require('./elk-api.js').default;

    Object.defineProperty(module.exports, "__esModule", {
      value: true
    });
    module.exports = ELK;
    ELK.default = ELK;
    },{"./elk-api.js":1}]},{},[2])(2)
    });
    });

    var ElkConstructor = /*@__PURE__*/getDefaultExportFromCjs(elkApi);

    var Debug = (function () {
        function Debug() {
        }
        Debug.log = function (message) {
            if (process.env.NODE_ENV !== "production") {
                console.log(message);
            }
        };
        Debug.warn = function (message) {
            if (process.env.NODE_ENV !== "production") {
                console.warn(message);
            }
        };
        Debug.error = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            console.error.apply(console, args);
        };
        Debug.never = function (value, message) {
            throw new Error(message !== null && message !== void 0 ? message : value + " is unexpected");
        };
        return Debug;
    }());

    var getNodeConfig = function (node, graphConfig) {
        var nodeConfig = graphConfig.getNodeConfigByName(node.shape);
        if (!nodeConfig) {
            Debug.warn("invalid shape in node " + JSON.stringify(node));
            return undefined;
        }
        return nodeConfig;
    };

    function getRectWidth(rectConfig, rect) {
        var _a;
        var minWidth = (_a = rectConfig === null || rectConfig === void 0 ? void 0 : rectConfig.getMinWidth(rect)) !== null && _a !== void 0 ? _a : 0;
        if (rect.width && rect.width >= minWidth) {
            return rect.width;
        }
        return minWidth;
    }
    function getRectHeight(rectConfig, rect) {
        var _a;
        var minHeight = (_a = rectConfig === null || rectConfig === void 0 ? void 0 : rectConfig.getMinHeight(rect)) !== null && _a !== void 0 ? _a : 0;
        if (rect.height && rect.height >= minHeight) {
            return rect.height;
        }
        return minHeight;
    }
    function getNodeSize(node, graphConfig) {
        var nodeConfig = getNodeConfig(node, graphConfig);
        var width = getRectWidth(nodeConfig, node);
        var height = getRectHeight(nodeConfig, node);
        return {
            height: height,
            width: width
        };
    }

    var getPortPosition = function (node, port, nodeConfig) {
        var width = getRectWidth(nodeConfig, node);
        var height = getRectHeight(nodeConfig, node);
        var xOffset = port.position ? port.position[0] * width : width * 0.5;
        var x = node.x + xOffset;
        var yOffset = port.position ? port.position[1] * height : height;
        var y = node.y + yOffset;
        return {
            x: x,
            y: y
        };
    };
    var getPortPositionByPortId = function (node, portId, graphConfig) {
        var nodeConfig = getNodeConfig(node, graphConfig);
        if (!nodeConfig) {
            return undefined;
        }
        var ports = node.ports || [];
        var port = ports.find(function (p) { return p.id === portId; });
        if (!port) {
            Debug.warn("invalid port id " + JSON.stringify(port));
            return undefined;
        }
        return getPortPosition(node, port, nodeConfig);
    };

    var defaultNodeLayoutOption = {
        "elk.portConstraints": "FIXED_ORDER"
    };
    var defaultGlobalLayoutOption = {
        "elk.algorithm": "layered",
        "elk.direction": "DOWN",
        "elk.edgeRouting": "SPLINES",
        "elk.spacing.nodeNode": "50",
        "elk.layered.spacing.nodeNodeBetweenLayers": "50"
    };
    var defaultWorkerFactory = function () {
        return new Worker("elkjs/lib/elk-worker.js", {
            type: "module",
            name: "elk-worker"
        });
    };
    var isWithinRange = function (lower, upper, target) {
        return target > lower && target < upper;
    };
    var getPortSideAndType = function (graphConfig, direction, node, port) {
        var threshold = 20;
        var pos = getPortPositionByPortId(node, port.id, graphConfig);
        if (!pos) {
            return {};
        }
        var side;
        var isOutput;
        if (direction === "DOWN" || direction === "UP") {
            if (isWithinRange(node.y - threshold, node.y + threshold, pos.y)) {
                side = "NORTH";
                isOutput = direction === "UP";
            }
            else {
                side = "SOUTH";
                isOutput = direction !== "UP";
            }
        }
        else {
            if (isWithinRange(node.x - threshold, node.x + threshold, pos.x)) {
                side = "WEST";
                isOutput = direction === "LEFT";
            }
            else {
                side = "EAST";
                isOutput = direction !== "LEFT";
            }
        }
        return {
            side: side,
            isOutput: isOutput
        };
    };
    function autoLayout(props) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var graphConfig, data, _b, portRadius, _c, workerFactory, _d, nodeLayoutOptions, _e, globalLayoutOption, elk, children, elkEdges, elkGraph, layout, nextData;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        graphConfig = props.graphConfig, data = props.data, _b = props.portRadius, portRadius = _b === void 0 ? 18 : _b, _c = props.workerFactory, workerFactory = _c === void 0 ? defaultWorkerFactory : _c;
                        _d = props.nodeLayoutOptions, nodeLayoutOptions = _d === void 0 ? {} : _d, _e = props.globalLayoutOption, globalLayoutOption = _e === void 0 ? {} : _e;
                        nodeLayoutOptions = __assign(__assign({}, defaultNodeLayoutOption), nodeLayoutOptions);
                        globalLayoutOption = __assign(__assign({}, defaultGlobalLayoutOption), globalLayoutOption);
                        elk = new ElkConstructor({ workerFactory: workerFactory });
                        children = [];
                        data.nodes.forEach(function (node) {
                            var minPortIndex = 0;
                            var maxPortIndex = node.ports && node.ports.length ? node.ports.length - 1 : 0;
                            var _a = getNodeSize(node, graphConfig), width = _a.width, height = _a.height;
                            children.push({
                                id: node.id,
                                width: width,
                                height: height,
                                ports: node.ports &&
                                    node.ports.map(function (port) {
                                        var _a = getPortSideAndType(graphConfig, globalLayoutOption["elk.direction"], node, port), side = _a.side, isOutput = _a.isOutput;
                                        var layoutOptions = side
                                            ? {
                                                "elk.port.side": side,
                                                "elk.port.index": isOutput ? (maxPortIndex--).toString() : (minPortIndex++).toString()
                                            }
                                            : {};
                                        return {
                                            id: node.id + ":" + port.id,
                                            width: portRadius * 2,
                                            height: portRadius * 2,
                                            layoutOptions: layoutOptions
                                        };
                                    }),
                                layoutOptions: nodeLayoutOptions
                            });
                        });
                        elkEdges = [];
                        data.edges.forEach(function (edge) {
                            elkEdges.push({
                                id: "edge_" + edge.id,
                                sources: [edge.source + ":" + edge.sourcePortId],
                                targets: [edge.target + ":" + edge.targetPortId],
                                sections: []
                            });
                        });
                        elkGraph = {
                            id: "root",
                            children: children,
                            edges: elkEdges,
                            layoutOptions: globalLayoutOption
                        };
                        return [4, elk.layout(elkGraph)];
                    case 1:
                        layout = _f.sent();
                        nextData = data;
                        (_a = layout.children) === null || _a === void 0 ? void 0 : _a.forEach(function (it) {
                            nextData = nextData.updateNode(it.id, function (prev) { return (__assign(__assign({}, prev), { x: (it.x || 0) + 200, y: (it.y || 0) + 100 })); });
                        });
                        return [2, nextData];
                }
            });
        });
    }

    exports.autoLayout = autoLayout;

    Object.defineProperty(exports, '__esModule', { value: true });

});
//# sourceMappingURL=vendor.js.map
